;program swiatel dziennych do samochodu

;po wlaczeniu jesli in_prog = 0 oczekuje na kalibracje

;kalibracja:
; 1. wlacz zasilanie
; 2. wlczas swiatla mijania na czas przez jaki ukad ma byc nie aktywny
; 3. wylacz swiatla
; 4. mignij swiatlami mijania tyle razy ile % mocy maja swiecc swiata drogowe
;	(kazde mignecie = 2% mocy)
; 5. wylacz zasilanie
; 6. koniec programowania

;ostatnie dwa bajty pam. (kalibracja) 54h, 34h
;obsluga timera timer0 - zmiana bitu LED
;bez preskalera
; ze wstepnym ustawieniem licznika na wartosc 206
;odlicza 50 cyki maszynowych (fosc/4)i zienia stan led

;definiowanie zmiennych
#define prog GPIO, 5			;wej. programowania GP5 - jesli programowanie =>0
#define lamp_m GPIO, 4			;swiatla mijania GP4 - jesli swieca =>1
#define lamp_day GPIO, 0		;swiatla dlugie/dzienne GP0 - 1-zalacza swiatla
;#define beeper GPIO, 1
#define dph 20h				;starszy bajt pomocniczy
#define dpl 21h				;mlodszy bajt pomocniczy
#define licznik h'22'			;pomocniczy licznik petli opoznienia
#define data_rd h'23'			;przepisanie danej z eeprom
#define stos h'24'				;pomocniczy rejestr zapamietujacy zmienne jak stos
#define time_off h'25'			;czas niekiego stanu na lampach

;deklaracj typu procesora i formatu liczb
	list p=12F675			;okreslenie typu procesora
	#include p12f675.inc	;dolaczenie pliku z nazwami

;konfiguracja procesora
	__config _INTRC_OSC_NOCLKOUT &_MCLRE_OFF &_WDT_OFF; gen wew. RC bez wyjscia 
									;wlaczone wejscie reset
									;watch dog wylaczony
	org 0
	goto start
	
	org 4
	goto timer_int	; (2CM)
start

;wylacz komparator
	movlw .7
	movwf cmcon

;wylacz adc
	bsf status, rp0 ;bank1
	clrf ansel
	bcf status, rp0 ;bank0
	clrf gpio ;inicjalizacja portow

;konfiguracja linii i/o
	bsf status, rp0;bank1

	movlw h'38'					;0011 1000   0=wyjscie, 1=wejscie
	movwf trisio
	movlw h'30'					;rezystor pull up na GP4 i 5 (31)
	movwf wpu
	bcf option_reg, 7				;zalacza wybrane w wpu rezystory do Vdd
							;GPPU=0 w rej option_reg 7 bit zalacza rezustory z rej. wpu
	bcf status, rp0 ;bank0

;ustawienia przerwania od timera0
;	bsf status, rp0	;bank1
;	movlw b'10001000'	;zliczanie cykli zegarowych bez preskalera
;	movwf option_reg
;	bcf status, rp0	;bank0
;	clrf intcon
;	clrf tmr0	;zeruje timer0 i preskaler
;	bsf intcon, t0ie	;zezwolenie na int od timer0
;	bcf intcon, gie	;ogolny bit zezwolenia na przerwania off

;wywolanie funkcji kalibracji generatora
;	call osc_cal 

;********************************************************
;program glowy
	bcf lamp_day		;zgas swiatla dzienne
	btfss prog	; jesli prog 1 => omin nastepna instr,
	call prog_mem	;wywolanie funkcji programowania
;#################################################################
;opoznienie dzialania eeprom(00h)x sec
	clrw			;w:=0 dres
	call eeprom_read
	movwf data_rd
	call delay1s
	decfsz data_rd, f
	goto $-2
;odczyt wypelnienia z eeprom
;eeprom(o1h) x2% = wypelnienie
	movlw h'01'	;zapisanie do W 01H adres
	call eeprom_read
	movwf licznik
;	movlw h'32'	;zapisuje 50 do W
;	subwf licznik, 0	;odejmuje W= 50 - licznik
	sublw h'32'
	movwf time_off
loop
	movf licznik, 0	
	movwf data_rd
	btfsc lamp_m	; jesli wyl swiatla mijania 0 => omin nastepna instr,
	goto	lamp_day_off
	bsf lamp_day
	call delay_ux100
	call delay_ux100
	decfsz data_rd, f
	goto $-3
	btfsc lamp_m	; jesli wyl swiatla mijania 0 => omin nastepna instr,
	goto	lamp_day_off
	bcf lamp_day
	movf time_off, 0	
	movwf data_rd
	bcf lamp_day
	call delay_ux100
	call delay_ux100
	decfsz data_rd, f
	goto $-3
	goto loop
lamp_day_off
	bcf lamp_day
	btfsc lamp_m	; jesli wyl swiatla mijania 0 => omin nastepna instr,
	goto	lamp_day_off
	goto loop

	goto $
;********************************************************
; funkcje pomocnicze
;obsluga przerwania od timera0
timer_int
	bcf intcon, t0if	;zeruje flage przerwania (1CM)
	bcf status, rp0	;bank0			(1CM)	
	movlw h'36'					;	(1CM)
	movwf tmr0	;	poczatkowa wartosc 204 + 2cykle na zaladowanie tmr0 (1CM)
	btfsc lamp_day; jesli led=0 omin next instr.	(1/2 CM)
	goto timer_int1					;(2CM)
	bsf lamp_day;	led bylo 0 => ustaw		;(1CM)
	goto timer_int_end				;(2CM)
timer_int1
	bcf lamp_day	;	ustawia led bo bylo 0	;(1CM)
timer_int_end
	retfie						;(2CM)

;fabryczna kalibracja generatora RC
;osc_cal
;	bsf status, rp0	;bank nr 1
;	call h'3ff'		;bobraie danych spd adr. 3ff do W
;	movwf osccal	;wyslanie danych z w o osccal
;	bcf status, rp0	;powrot do banku 0
;	return

;opoznienie o 100 us
delay_ux100
	movlw h'1c'		;1
delay_ux100b
	movwf dpl		;przepisuja W do dpl
	decfsz dpl,0	;1 dekrement, wynik do W, jesli 0 pomin next instr.
	goto delay_ux100b	;1
	return	


;opoznienie o 10 ms
delay10
	movlw h'0b'		;1 bylo 0bh
delay10a
	movwf dph		;1
	movlw h'f2'		;1
delay10b
	movwf dpl	;przepisuja W do dpl
	decfsz dpl,0		;1 dekrement, wynik do W, jesli 0 pomin next instr.
	goto delay10b	;1
	movlw dph	;	wpisz do W dph
	decfsz dph,0	;1 zmniejsz dph, wynik do W, jesli 0 pomin next instr.
	goto delay10a	;1
	return	

;opoznienie o 1 sek
delay1s
	movwf stos 	;zapamietuje W na stosie
	movlw .100
	movwf licznik
	call delay10
	decfsz licznik, f
	goto $-2
	movf stos,0	;oddaje wartosc W
	return

;blysk led co 1 sec
blink_led
	bsf lamp_day
	call delay1s
	bcf lamp_day
	call delay1s
	return
;odczyt z eeprom spod adr. W, dana zapisana do W
eeprom_read
	bsf status, rp0 ;bank1
	movwf eeadr		;wpisanie adresu z w eeadr
	bsf eecon1, rd	;odczyt z eeprom
	movf eedata, w	;przepisanie odczytanej danej do w
	bcf status, rp0 ;bank0
	return
;#########################################################################

;funkcja programowania pamieci eeprom
prog_mem
	call delay1s	;odczekaj 1sec
	movlw h'01'	;zapisanie do W 01H
prog_mem1
	call delay1s	;odczekaj 1sec
	btfss lamp_m	; jesli wlaczone swiatla mijania =  1 => omin nastepna instr,
	goto prog_mem2
	movwf	f	;przejlij w do f
	incf	f, 0	;inc f i zapisz do W
	goto prog_mem1
prog_mem2
	movwf data_rd	;przepisanie dnych z W do DATA_RD
				;zapis nowych danych do eeprom pod adr. 0
	bsf status, rp0 ;bank1
	clrw			;w:=0 dres
	movwf eeadr		;wpisanie adresu z w eeadr
	movf data_rd, 0	;dane do zapisu wyslane do W
	movwf eedata	;wyslanie danych do eedata
	bsf eecon1,wren	;zezwolenie na zapis
	movlw h'55'
	movwf eecon2
	movlw h'aa'
	movwf eecon2
	bsf eecon1,wr	;rozpoczecie zapisu
	btfsc eecon1, wr	;oczekiwanie na koniec zapisu
	goto $-1
	bcf eecon1, wren	;wyl. zezwolenia na zapis
	bcf status, rp0	;powrot do bank0
	;call delay10
	;call delay10
;******************************************************************************
				;programowanie czasu swiecenia swiatel dlugich w %
	movlw h'01'	;zapisanie do W 01H
	movwf data_rd		;wpisanie danych z w do data_rd

	bsf status, rp0 ;bank1
	movlw h'01'	;zapisanie do W 01H adres
	movwf eeadr		;wpisanie adresu z w eeadr
	movf data_rd, 0	;dane do zapisu wyslane do W
	movwf eedata	;wyslanie danych do eedata
	bsf eecon1,wren	;zezwolenie na zapis
	movlw h'55'
	movwf eecon2
	movlw h'aa'
	movwf eecon2
	bsf eecon1,wr	;rozpoczecie zapisu
	btfsc eecon1, wr	;oczekiwanie na koniec zapisu
	goto $-1
	bcf eecon1, wren	;wyl. zezwolenia na zapis
	bcf status, rp0	;powrot do bank0
prog_mem2a
	call delay10
	btfsc lamp_m	; jesli wylaczone swiatla mijania =  0 => omin nastepna instr,
	goto prog_mem2a
prog_mem3
	call delay10
	btfss lamp_m	; jesli wlaczone swiatla mijania =  1 => omin nastepna instr,
	goto prog_mem3
;odczyt z eeprom
	bsf status, rp0 ;bank1
	movlw h'01'	;zapisanie do W 01H
	movwf eeadr		;wpisanie adresu z w eeadr
	bsf eecon1, rd	;odczyt z eeprom
	movf eedata, w	;przepisanie odczytanej danej do w
	bcf status, rp0 ;bank0
	movwf	f	;przejlij w do f
	incf	f, 0	;inc f i zapisz do W
	movwf data_rd	;przeslij w do data_rd
;zapis nowych danych do eeprom pod adr. 0
	bsf status, rp0 ;bank1
	movlw h'01'	;zapisanie do W 01H
	movwf eeadr		;wpisanie adresu z w eeadr
	movf data_rd, 0	;dane do zapisu wyslane do W
	movwf eedata	;wyslanie danych do eedata
	bsf eecon1,wren	;zezwolenie na zapis
	movlw h'55'
	movwf eecon2
	movlw h'aa'
	movwf eecon2
	bsf eecon1,wr	;rozpoczecie zapisu
	btfsc eecon1, wr	;oczekiwanie na koniec zapisu
	goto $-1
	bcf eecon1, wren	;wyl. zezwolenia na zapis
	bcf status, rp0	;powrot do bank0
;koniec zapisu do eeprom
;punk nr 3 programowania - wykonany swiatala mijania swieca
	clrf licznik		;zeruje F
prog_mem4
	call delay10
	decfsz licznik, 0		;zmniejsz f o 1 i jesli F=0 omin nastepna instr
	goto prog_mem5
	goto prog_mem_end
prog_mem5
	movwf licznik
	btfsc lamp_m	; jesli wylaczone swiatla mijania =  0 => omin nastepna instr,
	goto prog_mem4
	goto prog_mem3
prog_mem_end
	goto $
	return
;*************************************************************************************
;sprawdzenie zawartosci eeprom
;blyska led tyle razy ile zawartosc kom. adr. 00h
; pauza
;blyska led tyle razy ile zawartosc kom. adr. 01h
eeprom_test
	clrw			;w:=0 dres
	call eeprom_read
;wyswietlenie odczytanej danej
;blysniecie led x eeprom
	movwf data_rd
	call blink_led
	decfsz data_rd, f
	goto $-2
;pauza
	call delay1s
	bsf lamp_day
	call delay1s
	call delay1s
	call delay1s
	bcf lamp_day
	call delay1s
;2 komorka eeprom
	movlw h'01'	;zapisanie do W 01H adres
	call eeprom_read
;wyswietlenie odczytanej danej
;blysniecie led x eeprom
	movwf data_rd
	call blink_led
	decfsz data_rd, f
	goto $-2
	goto $

	end
